﻿Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_90_Mask_201
Imports NM_Ahnen.cls_91_DB_Para

Public Class NM_Ahnen_Para

    Private Sub NM_Ahnen_Para_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Text = "Parameterdaten"
        Me.lbl_Para_Menue.BackColor = col_Back
        int_SelPara = 0
        Call MenueButtonSicht(True)
        Call Mask_Pos_200()
        Me.bt_200_Neu.Visible = False
        Me.bt_200_kpl.Visible = False

        int_Para_DB = 0

        Call Para_Datum_Load()
        Call Para_Altersgrenzen_Load()
        Call Para_Konf_Load()
        Call Para_Orte_Load()

    End Sub
    REM **************************************************************
    REM *  Buttonsteuerung der Startseite                            *
    REM **************************************************************
    Private Sub Bt_200_Allg_Click(sender As Object, e As EventArgs) Handles bt_200_Allg.Click
        Me.lbl_Para_Menue.Text = "Allg.Parameter"
        int_SelPara = 0
        Me.bt_200_Neu.Visible = True
    End Sub


    Private Sub Bt_200_Datum_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_200_Datum.Click
        Me.lbl_Para_Menue.Text = "Datumsarten"
        int_SelPara = 1
        Me.bt_200_Neu.Visible = True
        Call Para_Zeigen()
    End Sub

    Private Sub Bt_200_Alter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_200_Alter.Click
        Me.lbl_Para_Menue.Text = "Altersgrenzen"
        int_SelPara = 2
        Call Para_Zeigen()
    End Sub

    Private Sub Bt_200_Konf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_200_Konf.Click
        Me.lbl_Para_Menue.Text = "Konfessionen"
        int_SelPara = 3
        Me.bt_200_Neu.Visible = True
        Call Para_Zeigen()
    End Sub

    Private Sub Bt_200_Namen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_200_Namen.Click
        Me.lbl_Para_Menue.Text = "Namen"
        int_SelPara = 4
        Call Para_Namen_Load()
        Me.bt_200_Neu.Visible = True
        Me.bt_200_kpl.Visible = True
        Call Para_Zeigen()
    End Sub

    Private Sub Bt_200_Vornamen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_200_Vornamen.Click
        Me.lbl_Para_Menue.Text = "Vornamen"
        int_SelPara = 5
        Call Para_Vornamen_Load()
        Me.bt_200_Neu.Visible = True
        Call Para_Zeigen()
    End Sub

    Private Sub Bt_200_Beruf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_200_Beruf.Click
        Me.lbl_Para_Menue.Text = "Berufe"
        int_SelPara = 6
        Call Para_Beruf_Load()
        Me.bt_200_Neu.Visible = True
        Me.bt_200_kpl.Visible = True
        Call Para_Zeigen()
    End Sub

    Private Sub Bt_200_Ort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_200_Ort.Click
        Me.lbl_Para_Menue.Text = "Orte"
        int_SelPara = 7
        Me.bt_200_Neu.Visible = True
        Me.bt_200_kpl.Visible = True
        Call Para_Zeigen()
    End Sub

    Private Sub Bt_200_Todesursachen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_200_Todesursachen.Click
        Me.lbl_Para_Menue.Text = "Todesursachen"
        int_SelPara = 8
        Call Para_Tod_Load()
        Me.bt_200_Neu.Visible = True
        Me.bt_200_kpl.Visible = True
        Call Para_Zeigen()
    End Sub

    REM *----------------------------------------------*
    REM *  Ende Parameterbearbeitung                   *
    REM *----------------------------------------------*
    Private Sub Bt_200_Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_200_Cancel.Click
        Me.Close()
    End Sub

    REM *----------------------------------------------------------------*
    REM *  Bearbeitung mit OK abschließen                                *
    REM *----------------------------------------------------------------*
    Private Sub Bt_201_OK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_201_OK.Click
        If int_SelPara = 1 Then
            If int_Para_DB = 1 Then Call Para_Datum_DB_Insert()
            If int_Para_DB = 2 Then Call Para_Datum_DB_Update()
        End If
        If int_SelPara = 2 Then
            Call Para_Altersgrenze_DB_Update()
        End If
        If int_SelPara = 3 Then
            If int_Para_DB = 1 Then Call Para_Konf_DB_Insert()
            If int_Para_DB = 2 Then Call Para_Konf_DB_Update()
        End If
        If int_SelPara = 4 Then
            If int_Para_DB = 1 Then Call Para_Namen_Insert()
            If int_Para_DB = 2 Then Call Para_Namen_Update2()
        End If
        If int_SelPara = 5 Then
            If int_Para_DB = 1 Then Call Para_Vornamen_Insert()
            If int_Para_DB = 2 Then Call Para_Vornamen_Update2()
        End If
        If int_SelPara = 6 Then
            If int_Para_DB = 1 Then Call Para_Beruf_Insert()
            If int_Para_DB = 2 Then Call Para_Beruf_Update2()
        End If
        If int_SelPara = 7 Then
            If int_Para_DB = 1 Then Call Para_Orte_Insert()
            If int_Para_DB = 2 Then Call Para_Orte_Update()
        End If
        If int_SelPara = 8 Then
            If int_Para_DB = 1 Then Call Para_Tod_Insert()
            If int_Para_DB = 2 Then Call Para_Tod_Update2()
        End If

    End Sub

    REM *-------------------------------------------------------------*
    REM *  Abbruch der Maskenverarbeitung                             *
    REM *-------------------------------------------------------------*
    Private Sub Bt_201_Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_201_Cancel.Click
        Me.Text = "Parameterdaten"
        int_SelPara = 0
        Me.tb_Para.SelectTab(int_SelPara)
        Call MenueButtonSicht(True)
        Me.bt_200_Neu.Visible = False
        Me.bt_200_kpl.Visible = False
        Me.tb_Para.Show()

    End Sub

    REM **************************************************************
    REM *  Steuerung bei Datumsvarianten                             *
    REM **************************************************************
    Private Sub Bt_205_Aend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        int_Para_DB = 2
        Call ButtonSicht(True)
        Call Para_Orte_Update()

    End Sub

    Private Sub Tb_Para_Beruf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_Para_Beruf.Click

    End Sub

    REM *---------------------------------------------------------------------*
    REM *  Steuerung bei Neuanlage                                            *
    REM *---------------------------------------------------------------------*
    Private Sub Bt_200_Neu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_200_Neu.Click
        int_Para_DB = 1
        Call ButtonSicht(True)
        If int_SelPara = 1 Then Call Para_Datum_Neu()
        If int_SelPara = 3 Then Call Para_Konf_Neu()
        If int_SelPara = 4 Then Call Para_Namen_Neu()
        If int_SelPara = 5 Then Call Para_Vornamen_Neu()
        If int_SelPara = 6 Then Call Para_Beruf_Neu()
        If int_SelPara = 7 Then Call Para_Orte_Neu()
        If int_SelPara = 8 Then Call Para_Tod_Neu()

    End Sub

    REM *---------------------------------------------------------------------*
    REM *  Steuerung bei Datenaufbau                                          *
    REM *---------------------------------------------------------------------*
    Private Sub Bt_200_kpl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_200_kpl.Click
        Me.Cursor = Cursors.WaitCursor
        int_Para_DB = 1
        If int_SelPara = 4 Then Call Para_Namen_Aufbau()
        If int_SelPara = 7 Then
            int_Merk_Orte1 = 1
            Call Para_Orte_Aufbau()
            int_Merk_Orte1 = 0
        End If
        'If int_SelPara = 6 Then Call Para_Beruf_Aufbau()
        If int_SelPara = 8 Then Call Para_Tod_Aufbau()

        Me.Cursor = Cursors.Default
    End Sub

    REM **************************************************************
    REM *  Steuerung bei Grid-Auswahl                                *
    REM **************************************************************
    Private Sub Dgv_201_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Datum.CellContentClick
        Call ButtonSicht(True)
        int_Para_DB = 2
        Call Para_Datum_Update()
    End Sub
    Private Sub Dgv_203_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Konf.CellContentClick
        Call ButtonSicht(True)
        int_Para_DB = 2
        Call Para_Konf_Update()
    End Sub

    Private Sub Dgv_204_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Name.CellContentClick
        Call ButtonSicht(True)
        int_Para_DB = 2
        Call Para_Namen_Update()
    End Sub

    Private Sub Dgv_206_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Vorname.CellContentClick
        int_Para_DB = 2
        Call ButtonSicht(True)
        Call Para_Vornamen_Update()
    End Sub

    Private Sub Dgv_207_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Tod.CellContentClick
        Call ButtonSicht(True)
        int_Para_DB = 2
        Call Para_Tod_Update()
    End Sub

    Private Sub Dgv_208_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Beruf.CellContentClick
        Call ButtonSicht(True)
        int_Para_DB = 2
        Call Para_Beruf_Update()
    End Sub

    REM *---------------------------------------------------------*
    REM *  Label und Texte für Einzeldaten (un)sichtbar stellen   *
    REM *---------------------------------------------------------*
    Private Sub ButtonSicht(ByVal b_Vis As Boolean)
        Me.lbl_201_Text.Visible = b_Vis
        Me.lbl_203_TextKurz.Visible = b_Vis
        Me.lbl_203_TextLang.Visible = b_Vis
        Me.lbl_204_Bez.Visible = b_Vis
        Me.lbl_205_LfdNr.Visible = b_Vis
        Me.lbl_205_Ort1.Visible = b_Vis
        Me.lbl_205_Ort2.Visible = b_Vis
        Me.lbl_205_Ort3.Visible = b_Vis
        Me.lbl_206_Bez.Visible = b_Vis
        Me.lbl_207_Bez.Visible = b_Vis
        Me.lbl_208_Bez.Visible = b_Vis

        Me.tx_201_Text.Visible = b_Vis
        Me.tx_203_TextKurz.Visible = b_Vis
        Me.tx_203_TextLang.Visible = b_Vis
        Me.tx_204_Bez.Visible = b_Vis
        Me.tx_205_LfdNr.Visible = b_Vis
        Me.tx_205_Ort1.Visible = b_Vis
        Me.tx_205_Ort2.Visible = b_Vis
        Me.tx_205_Ort3.Visible = b_Vis
        Me.tx_206_Bez.Visible = b_Vis
        Me.tx_207_Bez.Visible = b_Vis
        Me.tx_208_Bez.Visible = b_Vis

    End Sub

    REM *--------------------------------------------------------*
    REM *  Menübersicht ein- bzw. ausblenden                     *
    REM *--------------------------------------------------------*
    Private Sub MenueButtonSicht(ByVal b_Menue As Boolean)
        Me.bt_200_Alter.Visible = b_Menue
        Me.bt_200_Beruf.Visible = b_Menue
        Me.bt_200_Datum.Visible = b_Menue
        Me.bt_200_Konf.Visible = b_Menue
        Me.bt_200_Namen.Visible = b_Menue
        Me.bt_200_Ort.Visible = b_Menue
        Me.bt_200_Todesursachen.Visible = b_Menue
        Me.bt_200_Vornamen.Visible = b_Menue
        Me.bt_200_Cancel.Visible = b_Menue
    End Sub

    REM *--------------------------------------------------------*
    REM *  einzelne Tabs anzeigen                                *
    REM *--------------------------------------------------------*
    Private Sub Para_Zeigen()
        Call ButtonSicht(False)
        Call MenueButtonSicht(False)
        Me.tb_Para.SelectTab(int_SelPara)
        Me.tb_Para.Show()
    End Sub

End Class