﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports System.Data.Odbc
Imports System.Data.Common
Imports System.Data.SqlClient
Imports System.Windows.Forms
Imports System.Drawing
Imports System.Math
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_09_Mask_Person

Public Class Cls_03_DB_Person_Update

    REM **************************************************************
    REM *  Updaten der Personen-Basisdaten                           *
    REM **************************************************************
    Public Shared Sub Person_Update_T01()

        str_Where = "where t01_ID = " + dbl_ID.ToString

        mySelect.CommandText = "update t01_Person set " & str_UString & str_Where
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Updaten der Personen-Taufdaten                            *
    REM **************************************************************
    Public Shared Sub Person_Update_T02()

        str_Where = "where t02_ID = " + dbl_ID.ToString

        mySelect.CommandText = "update t02_Taufe set " & str_UString & str_Where
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Updaten der Personen-Beerdigungsdaten                     *
    REM **************************************************************
    Public Shared Sub Person_Update_T03()

        str_Where = "where t03_ID = " + dbl_ID.ToString

        mySelect.CommandText = "update t03_Beerd set " & str_UString & str_Where
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Updaten der Personen-Ehedaten                             *
    REM **************************************************************
    Public Shared Sub Person_Update_T041()

        str_Where = "where t041_ID = " + dbl_ID.ToString

        mySelect.CommandText = "update t041_Ehedaten set " & str_UString & str_Where
        Call DB_Execute()

    End Sub


    REM **************************************************************
    REM *  Updaten der Personen-Adressdaten                          *
    REM **************************************************************
    Public Shared Sub Person_Update_T06()

        str_Where = "where t06_FK_t01 = " + dbl_ID.ToString + " and t06_Lfd = " + p_int_Adr_Lfd.ToString

        mySelect.CommandText = "update t06_Adr set " & str_UString & str_Where
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Updaten der Personen-Basisdaten (Änderungsdatum)          *
    REM **************************************************************
    Public Shared Sub Person_Update_T01_ADat()

        str_Where = "where t01_ID = " + dbl_ID.ToString

        mySelect.CommandText = "update t01_Person set " & str_UString1 & str_Where
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Updaten der Vaterfunktion                                 *
    REM **************************************************************
    Public Shared Sub Person_Vater_Update()

        str_Where = " where t01_ID = " & dbl_ID.ToString
        str_Tab = "t01_Vater = " + dbl_Sel_ID.ToString
        str_Tab += " and t01_AendDat = " + str_AktDat

        mySelect.CommandText = "update t01_Person set " & str_Tab & str_Where
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Updaten der Mutterfunktion                                *
    REM **************************************************************
    Public Shared Sub Person_Mutter_Update()

        str_Where = " where t01_ID = " & dbl_ID.ToString
        str_Tab = "t01_Mutter = " + dbl_Sel_ID.ToString
        str_Tab += " and t01_AendDat = " + str_AktDat

        mySelect.CommandText = "update t01_Person set " & str_Tab & str_Where
        Call DB_Execute()

    End Sub



    REM **************************************************************
    REM *  Inserten der Ehedaten (Partner)                           *
    REM **************************************************************
    Public Shared Sub Person_Ehe_Insert()

        REM *--------------------------------------------------------*
        REM *  Ermitteln nächste ID in Tabelle t041_Ehedaten         *
        REM *--------------------------------------------------------*
        Call DB_Tab_High("t041_ID", "t041_EheDaten")
        dbl_Max_ID += 1

        REM *--------------------------------------------------------*
        REM *  Leersatz in t041_Ehedaten anlegen                     *
        REM *--------------------------------------------------------*
        Call Person_Ehe041_Neu()

        REM *--------------------------------------------------------*
        REM *  Ermitteln nächste ID in Tabelle t04_Ehe               *
        REM *--------------------------------------------------------*
        Call DB_Tab_High("t04_ID", "t04_Ehe")
        dbl_Max_ID += 1

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t04 anlegen (Variante 1)              *
        REM *--------------------------------------------------------*
        str_DBD_t04 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t04 += "'" + dbl_ID.ToString + "',"
        str_DBD_t04 += "'" + dbl_Sel_ID.ToString + "',"
        str_DBD_t04 += "'" + dbl_T04_Max1.ToString + "')"

        mySelect.CommandText = "insert into t04_Ehe " & str_DBS_t04 & str_DBD_t04
        Call DB_Execute()

        REM *--------------------------------------------------------*
        REM *  Ermitteln nächste ID in Tabelle t04_Ehe               *
        REM *--------------------------------------------------------*
        Call DB_Tab_High("t04_ID", "t04_Ehe")
        dbl_Max_ID += 1

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t04 anlegen (Variante 2)              *
        REM *--------------------------------------------------------*
        str_DBD_t04 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t04 += "'" + dbl_Sel_ID.ToString + "',"
        str_DBD_t04 += "'" + dbl_ID.ToString + "',"
        str_DBD_t04 += "'" + dbl_T04_Max1.ToString + "')"

        mySelect.CommandText = "insert into t04_Ehe " & str_DBS_t04 & str_DBD_t04
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Neuanlage eines T041-Datensatzes mit Leereinträgen        *
    REM **************************************************************
    Public Shared Sub Person_Ehe041_Neu()

        str_DBD_t041 = " values ('" + dbl_T04_Max1.ToString + "',"
        str_DBD_t041 += "' ',"                  ' Dat1_TT
        str_DBD_t041 += "' ',"                  ' Dat1_MM
        str_DBD_t041 += "' ',"                  ' Dat1_JJ
        str_DBD_t041 += "'01.01.0001',"         ' Dat1
        str_DBD_t041 += "'0',"                  ' Dat1_Art
        str_DBD_t041 += "' ',"                  ' Ort1
        str_DBD_t041 += "' ',"                  ' Beamter
        str_DBD_t041 += "' ',"                  ' Urk1
        str_DBD_t041 += "' ',"                  ' Dat2_TT
        str_DBD_t041 += "' ',"                  ' Dat2_MM
        str_DBD_t041 += "' ',"                  ' Dat2_JJ
        str_DBD_t041 += "' ',"                  ' Dat2
        str_DBD_t041 += "'0',"                  ' Dat2_Art
        str_DBD_t041 += "' ',"                  ' Ort2
        str_DBD_t041 += "' ',"                  ' Kirche
        str_DBD_t041 += "' ',"                  ' Priester
        str_DBD_t041 += "' ',"                  ' Urk2
        str_DBD_t041 += "' ',"                  ' Dat3_TT
        str_DBD_t041 += "' ',"                  ' Dat3_MM
        str_DBD_t041 += "' ',"                  ' Dat3_JJ
        str_DBD_t041 += "' ',"                  ' Dat3
        str_DBD_t041 += "'0',"                  ' Dat3_Art
        str_DBD_t041 += "' ',"                  ' Urk3
        str_DBD_t041 += "' ',"                  ' Komm01
        str_DBD_t041 += "' ',"                  ' Komm02
        str_DBD_t041 += "' ',"                  ' Komm03
        str_DBD_t041 += "' ',"                  ' Komm04
        str_DBD_t041 += "' ',"                  ' Komm05
        str_DBD_t041 += "' ',"                  ' Komm06
        str_DBD_t041 += "' ',"                  ' Komm07
        str_DBD_t041 += "' ',"                  ' Komm08
        str_DBD_t041 += "' ',"                  ' Komm09
        str_DBD_t041 += "' ',"                  ' Komm10
        str_DBD_t041 += "' ',"                  ' Komm11
        str_DBD_t041 += "' ',"                  ' Komm12
        str_DBD_t041 += "' ',"                  ' Komm13
        str_DBD_t041 += "' ')"                  ' Bemerkung

        mySelect.CommandText = "insert into t041_EheDaten " & str_DBS_t041 & str_DBD_t041
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Updaten der Trauzeugen                                    *
    REM **************************************************************
    Public Shared Sub Person_Trauzeugen_Insert()

        REM *--------------------------------------------------------*
        REM *  Ermitteln nächste ID in Tabelle t05_Rolle             *
        REM *--------------------------------------------------------*
        Call DB_Tab_High("t05_ID", "t05_Rolle")
        dbl_Max_ID += 1

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t05 anlegen (Variante 1)              *
        REM *--------------------------------------------------------*
        str_DBD_t05 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t05 += "'" + dbl_ID.ToString + "',"
        str_DBD_t05 += "'" + int_TZ_Typ.ToString + "',"
        str_DBD_t05 += "'" + dbl_Sel_ID.ToString + "')"

        mySelect.CommandText = "insert into t05_Rolle " & str_DBS_t05 & str_DBD_t05
        Call DB_Execute()

        REM **********************************************************
        REM *  Eintragen der Daten für Ehepartner                    *
        REM **********************************************************

        REM *--------------------------------------------------------*
        REM *  Ermitteln nächste ID in Tabelle t05_Rolle             *
        REM *--------------------------------------------------------*
        Call DB_Tab_High("t05_ID", "t05_Rolle")
        dbl_Max_ID += 1

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t05 anlegen (Variante 1)              *
        REM *--------------------------------------------------------*
        str_DBD_t05 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t05 += "'" + p_int_Ehe41.ToString + "',"
        str_DBD_t05 += "'" + int_TZ_Typ.ToString + "',"
        str_DBD_t05 += "'" + dbl_Sel_ID.ToString + "')"

        mySelect.CommandText = "insert into t05_Rolle " & str_DBS_t05 & str_DBD_t05
        Call DB_Execute()

        REM *--------------------------------------------------------*
        REM *  Ermitteln nächste ID in Tabelle t05_Rolle             *
        REM *--------------------------------------------------------*
        Call DB_Tab_High("t05_ID", "t05_Rolle")
        dbl_Max_ID += 1
        int_TZ_Typ = 7

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t05 anlegen (Variante 2)              *
        REM *--------------------------------------------------------*
        str_DBD_t05 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t05 += "'" + dbl_Sel_ID.ToString + "',"
        str_DBD_t05 += "'" + int_TZ_Typ.ToString + "',"
        str_DBD_t05 += "'" + dbl_ID.ToString + "')"

        mySelect.CommandText = "insert into t05_Rolle " & str_DBS_t05 & str_DBD_t05
        Call DB_Execute()

        REM **********************************************************
        REM *  Eintragen der Daten für Ehepartner                    *
        REM **********************************************************

        REM *--------------------------------------------------------*
        REM *  Ermitteln nächste ID in Tabelle t05_Rolle             *
        REM *--------------------------------------------------------*
        Call DB_Tab_High("t05_ID", "t05_Rolle")
        dbl_Max_ID += 1
        int_TZ_Typ = 7

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t05 anlegen (Variante 2)              *
        REM *--------------------------------------------------------*
        str_DBD_t05 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t05 += "'" + dbl_Sel_ID.ToString + "',"
        str_DBD_t05 += "'" + int_TZ_Typ.ToString + "',"
        str_DBD_t05 += "'" + p_int_Ehe41.ToString + "')"

        mySelect.CommandText = "insert into t05_Rolle " & str_DBS_t05 & str_DBD_t05
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Löschen von Trauzeugen-Verbindungen                       *
    REM **************************************************************
    Public Shared Sub Person_Trauzeugen_Delete()

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t05 löschen (Variante 1)              *
        REM *--------------------------------------------------------*
        str_Where = " where t05_FK_t01 = " + dbl_ID.ToString + " and t05_Typ = " + int_TZ_Typ.ToString + " and t05_FK_Rolle = " + dbl_Sel_ID.ToString
        mySelect.CommandText = "delete * from t05_Rolle " & str_Where
        Call DB_Execute()

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t05 löschen (Variante 1 Partner)      *
        REM *--------------------------------------------------------*
        str_Where = " where t05_FK_t01 = " + p_int_Ehe41.ToString + " and t05_Typ = " + int_TZ_Typ.ToString + " and t05_FK_Rolle = " + dbl_Sel_ID.ToString
        mySelect.CommandText = "delete * from t05_Rolle " & str_Where
        Call DB_Execute()

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t05 löschen (Variante 2)              *
        REM *--------------------------------------------------------*
        int_TZ_Typ = 7
        str_Where = " where t05_FK_t01 = " + dbl_Sel_ID.ToString + " and t05_Typ = " + int_TZ_Typ.ToString + " and t05_FK_Rolle = " + dbl_ID.ToString
        mySelect.CommandText = "delete * from t05_Rolle " & str_Where
        Call DB_Execute()

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t05 löschen (Variante 2 Partner)      *
        REM *--------------------------------------------------------*
        int_TZ_Typ = 7
        str_Where = " where t05_FK_t01 = " + dbl_Sel_ID.ToString + " and t05_Typ = " + int_TZ_Typ.ToString + " and t05_FK_Rolle = " + p_int_Ehe41.ToString
        mySelect.CommandText = "delete * from t05_Rolle " & str_Where
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Löschen von Paten-Verbindungen                            *
    REM **************************************************************
    Public Shared Sub Person_Paten_Delete()

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t05 löschen (Variante 1)              *
        REM *--------------------------------------------------------*
        int_TZ_Typ = 6
        str_Where = " where t05_FK_t01 = " + dbl_ID.ToString + " and t05_Typ = " + int_TZ_Typ.ToString + " and t05_FK_Rolle = " + dbl_Sel_ID.ToString
        mySelect.CommandText = "delete * from t05_Rolle " & str_Where
        Call DB_Execute()

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t05 löschen (Variante 2)              *
        REM *--------------------------------------------------------*
        int_TZ_Typ = 5
        str_Where = " where t05_FK_t01 = " + dbl_Sel_ID.ToString + " and t05_Typ = " + int_TZ_Typ.ToString + " and t05_FK_Rolle = " + dbl_ID.ToString
        mySelect.CommandText = "delete * from t05_Rolle " & str_Where
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Updaten der Paten                                         *
    REM **************************************************************
    Public Shared Sub Person_Paten_Insert()

        REM *--------------------------------------------------------*
        REM *  Ermitteln nächste ID in Tabelle t05_Rolle             *
        REM *--------------------------------------------------------*
        Call DB_Tab_High("t05_ID", "t05_Rolle")
        dbl_Max_ID += 1
        int_TZ_Typ = 6

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t05 anlegen (Variante 1)              *
        REM *--------------------------------------------------------*
        str_DBD_t05 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t05 += "'" + dbl_ID.ToString + "',"
        str_DBD_t05 += "'" + int_TZ_Typ.ToString + "',"
        str_DBD_t05 += "'" + dbl_Sel_ID.ToString + "')"

        mySelect.CommandText = "insert into t05_Rolle " & str_DBS_t05 & str_DBD_t05
        Call DB_Execute()

        REM *--------------------------------------------------------*
        REM *  Ermitteln nächste ID in Tabelle t05_Rolle             *
        REM *--------------------------------------------------------*
        Call DB_Tab_High("t05_ID", "t05_Rolle")
        dbl_Max_ID += 1
        int_TZ_Typ = 5

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t05 anlegen (Variante 2)              *
        REM *--------------------------------------------------------*
        str_DBD_t05 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t05 += "'" + dbl_Sel_ID.ToString + "',"
        str_DBD_t05 += "'" + int_TZ_Typ.ToString + "',"
        str_DBD_t05 += "'" + dbl_ID.ToString + "')"

        mySelect.CommandText = "insert into t05_Rolle " & str_DBS_t05 & str_DBD_t05
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Eintragen in Aufgaben-Tabelle (toDo)                      *
    REM **************************************************************
    Public Shared Sub Person_Aufgabe_Insert()

        REM *--------------------------------------------------------*
        REM *  Ermitteln nächste ID in Tabelle t99_Aufgabe           *
        REM *--------------------------------------------------------*
        Call DB_Tab_High("t99_ID", "t99_Aufgabe")
        dbl_Max_ID += 1

        REM *--------------------------------------------------------*
        REM *  Ermitteln nächste ID in Tabelle t99_Aufgabe           *
        REM *--------------------------------------------------------*
        Call DB_T99_LFD_High()
        int_Max_LFD += 1

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t99 anlegen                           *
        REM *--------------------------------------------------------*
        With NM_Ahnen_PersK
            str_DBD_t99 = " values ('" + dbl_Max_ID.ToString + "',"
            str_DBD_t99 += "'" + dbl_Pers_ID.ToString + "',"
            str_DBD_t99 += "'" + int_Max_LFD.ToString + "', "
            str_DBD_t99 += "'" + .tx_301_Name.Text + "', "
            str_DBD_t99 += "'" + .tx_301_GebName.Text + "', "
            str_DBD_t99 += "'" + .tx_301_Vorname.Text + "', "
            str_DBD_t99 += "'" + .tx_301_GDat_TT.Text + "." + .tx_301_GDat_MM.Text + "." + .tx_301_GDat_JJ.Text + "', "
            str_DBD_t99 += "'" + GM5_TabIndex.ToString + "',"
            str_DBD_t99 += "'" + int_NM_FeldNr.ToString + "',"
            str_DBD_t99 += "'" + str_Aufgabe + " # " + dbl_ID.ToString + "')"
        End With

        str_Tab = str_DBS_t99 + str_DBD_t99

        mySelect.CommandText = "insert into t99_Aufgabe " & str_Tab
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Eintragen in Personen-Tabelle (toDo)                      *
    REM **************************************************************
    Public Shared Sub Person_T01_Aufgabe_Insert()

        Dim str_Null As Integer = 0

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t01 anlegen                           *
        REM *--------------------------------------------------------*
        With NM_Ahnen_PersK

            str_DBD_t01 = " values (" + dbl_Max_ID.ToString + ", "     ' Personen_ID
            str_DBD_t01 += "'" + .tx_301_Name.Text + "', "             ' Name
            str_DBD_t01 += "'" + .tx_301_GebName.Text + "', "          ' Geburtsname
            str_DBD_t01 += "'', "                                      ' Namenszusatz
            str_DBD_t01 += "'" + .tx_301_Vorname.Text + "', "          ' Vorname
            str_DBD_t01 += "'', "                                      ' Rufname
            str_DBD_t01 += "'', "                                      ' Spitzname
            str_DBD_t01 += "'', "                                      ' Titel
            str_DBD_t01 += "'" + .tx_301_Geschl.Text + "', "           ' Geschlecht
            str_DBD_t01 += str_Null.ToString + ", "                    ' Vater
            str_DBD_t01 += str_Null.ToString + ", "                    ' Mutter
            str_DBD_t01 += "'" + .tx_301_GDat_TT.Text + "', "          ' Geburtsdatum (Tag)
            str_DBD_t01 += "'" + .tx_301_GDat_MM.Text + "', "          ' Geburtsdatum (Monat)
            str_DBD_t01 += "'" + .tx_301_GDat_JJ.Text + "', "          ' Geburtsdatum (Jahr)
            str_Dat_H = .tx_301_GDat_TT.Text + "." + .tx_301_GDat_MM.Text + "." + .tx_301_GDat_JJ.Text
            'dt_Date = CType(str_Dat_H, Date)
            str_DBD_t01 += "'" + str_Dat_H + "', "                       ' Geburtsdatum 
            str_DBD_t01 += str_Null.ToString + ", "                    ' GebDatum-Art
            str_DBD_t01 += "'', "                                      ' GebOrt
            str_DBD_t01 += "'', "                                      ' Geb-Urkunde
            str_DBD_t01 += "'', "                                      ' Sterbedatum (Tag)
            str_DBD_t01 += "'', "                                      ' Sterbedatum (Monat)
            str_DBD_t01 += "'', "                                      ' Sterbedatum (Jahr)
            str_Dat_H = "31.12.9999"
            'dt_Date = CType(str_Dat_H, Date)
            str_DBD_t01 += "'" + str_Dat_H + "', "                       ' Sterbedatum 
            str_DBD_t01 += str_Null.ToString + ", "                    ' Sterbedatum-Art
            str_DBD_t01 += "'', "                                      ' Sterbeort
            str_DBD_t01 += "'', "                                      ' Sterbeurkunde
            str_DBD_t01 += "'', "                                      ' Search-Name
            str_DBD_t01 += "'', "                                      ' Search-GebName
            str_DBD_t01 += "'', "                                      ' Search-SpitzN
            str_DBD_t01 += "'', "                                      ' Search-NameZ
            str_DBD_t01 += "'" + str_AktDat + "', "                    ' NeuDat
            str_DBD_t01 += "'')"                                       ' AendDat

        End With

        mySelect.CommandText = "insert into t01_Person " & str_DBS_t01 & str_DBD_t01
        Call DB_Execute()

    End Sub

End Class
