﻿Imports System.Windows.Forms
Imports System.Drawing
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_10_Mask_01
Imports NM_Ahnen.cls_10_Mask_10
Imports NM_Ahnen.cls_10_Mask_11
Imports NM_Ahnen.cls_10_Mask_12
Imports NM_Ahnen.cls_10_Mask_13
Imports NM_Ahnen.cls_10_Mask_14
Imports NM_Ahnen.cls_10_Mask_15
Imports NM_Ahnen.cls_10_Mask_16
Imports NM_Ahnen.cls_10_Mask_17
Imports NM_Ahnen.cls_80_Mask_91
Imports NM_Ahnen.cls_90_Mask_201

REM *****************************************************************
REM *  Grundklasse für alle Maskenfelder und -größen                *
REM *****************************************************************
Class Cls_10_Mask

    Public Shared Sub Mask_Pos()

        NM_Ahnen.Width = int_Screen_W
        NM_Ahnen.Height = int_Screen_H
        NM_Ahnen.Location = New System.Drawing.Point(0, 0)

        Call MaskDim()
        Call Mask_Menue()
        Call Mask_Navi()
        Call Mask_Pos_Status()
        Call Mask_Pos_00()
        Call Mask_Pos_01()
        Call Mask_Pos_10()
        Call Mask_Pos_11()
        Call Mask_Pos_12()
        Call Mask_Pos_13()
        Call Mask_Pos_14()
        Call Mask_Pos_15()
        Call Mask_Pos_16()
        Call Mask_Pos_17()

        Call Mask_Pos_91()
        Call Mask_Pos_201()

    End Sub

    REM *************************************************************
    REM *  Größenübertragung der Maskengrundelemente                *
    REM *************************************************************
    Public Shared Sub Mask_Pos_00()

        With NM_Ahnen

            .Stat.Location = New System.Drawing.Point(int_Screen_H - int_Stst_Height)
            .pan_Daten.Location = New System.Drawing.Point(5, int_Navi_Height + int_Menue_Height)
            'SplitContainer1
            '
            .spc1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
            .spc1.Location = New System.Drawing.Point(1, 1 + int_Navi_Height + int_Menue_Height)
            .spc1.Size = New System.Drawing.Size(int_spc1_width, int_spc1_height)
            .spc1.SplitterDistance = int_SplitDisW
            '
            'SplitContainer1.Panel1
            '
            .spc1.Panel1.BackColor = col_Back
            .spc1.Panel1.Location = New System.Drawing.Point(1, 1)

            .gbx_01_Ansicht.Location = New System.Drawing.Point(10, 1)
            .gbx_01_Ansicht.MinimumSize = New System.Drawing.Size(int_gbx_Width, int_gbx_Height)
            .gbx_01_Ansicht.Size = New System.Drawing.Size(int_gbx_Width, int_gbx_Height)

            'SplitContainer1.Panel2
            '
            .spc1.Panel2.BackColor = col_Back
            .spc1.Panel2.Location = New System.Drawing.Point(1, 1)

            .gbx_01_Person.Location = New System.Drawing.Point(10, 1)
            .gbx_01_Person.MinimumSize = New System.Drawing.Size(int_gbx_Width - 25, int_gbx_Height)
            .gbx_01_Person.Size = New System.Drawing.Size(int_gbx_Width - 25, int_gbx_Height)

            .lbx_01_Person.Location = New System.Drawing.Point(3, 12)
            .lbx_01_Person.BorderStyle = System.Windows.Forms.BorderStyle.None
            .lbx_01_Person.Font = font_Foretext
            .lbx_01_Person.MinimumSize = New System.Drawing.Size(int_gbx_Width - 30, int_gbx_Height - 20)
            .lbx_01_Person.Size = New System.Drawing.Size(int_gbx_Width - 30, int_gbx_Height - 20)
            .lbx_01_Person.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            .bt_xx_OK.Location = New System.Drawing.Point(3 + int_gbx_Width - 10, 15)
            .bt_xx_OK.BackColor = col_btn
            .bt_xx_OK.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_xx_OK.MinimumSize = New System.Drawing.Size(int_bt_OK_Width, int_bt_OK_Height)
            .bt_xx_OK.Size = New System.Drawing.Size(int_bt_OK_Width, int_bt_OK_Height)
            .bt_xx_OK.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            .bt_xx_OK.Visible = False

            .bt_xx_Cancel.Location = New System.Drawing.Point(3 + int_gbx_Width - 5 + int_Navi_Button_Width, 15)
            .bt_xx_Cancel.BackColor = col_btn
            .bt_xx_Cancel.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_xx_Cancel.MinimumSize = New System.Drawing.Size(int_bt_OK_Width, int_bt_OK_Height)
            .bt_xx_Cancel.Size = New System.Drawing.Size(int_bt_OK_Width, int_bt_OK_Height)
            .bt_xx_Cancel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            .bt_xx_Cancel.Visible = False

            Dim int_Item_Width As Integer = (int_tab_Width - 20) / 8
            Dim int_Item_Height As Integer = 20
            .tb1.Location = New System.Drawing.Point(10, 10 + int_gbx_Height)
            .tb1.MinimumSize = New System.Drawing.Size(int_tab_Width, int_tab_Height)
            .tb1.Size = New System.Drawing.Size(int_tab_Width, int_tab_Height)
            .tb1.SizeMode = TabSizeMode.Fixed
            .tb1.ItemSize = New Size(int_Item_Width, int_Item_Height)

            .bt_xx_OK.Location = New System.Drawing.Point(3 + int_gbx_Width - 10, 15 + int_gbx_Height + int_tab_Height)
            .bt_xx_OK.BackColor = col_btn
            .bt_xx_OK.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_xx_OK.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_xx_OK.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_xx_OK.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            .bt_xx_OK.Visible = False

            .bt_xx_Cancel.Location = New System.Drawing.Point(3 + int_gbx_Width - 5 + int_Navi_Button_Width, 15 + int_gbx_Height + int_tab_Height)
            .bt_xx_Cancel.BackColor = col_btn
            .bt_xx_Cancel.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_xx_Cancel.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_xx_Cancel.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_xx_Cancel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            .bt_xx_Cancel.Visible = False

        End With

    End Sub

    REM *****************************************************************
    REM *  Ermitteln der Maskengrößen anhand Bildschirmgrößen           *
    REM *****************************************************************
    Public Shared Sub MaskDim()

        With NM_Ahnen

            int_SC_FormW = int_Screen_W
            int_SC_FormH = int_Screen_H

            'int_SC_FormW = 1024
            'int_SC_FormH = 768

            REM *--------------------------------------------------------*
            REM *  Anpassung der Schriften und Fonts bei anderer         *
            REM *  (kleinerer) Bildschirmauflösung                       *
            REM *--------------------------------------------------------*
            If int_SC_FormH < 800 Then
                font_Foretext = font_Foretext_1024
                font_Label = font_Label_1024
                'font_HeadLbl = font_HeadLbl_1024
                'font_Head = font_Head_1024
                'int_Box_h = int_Box_h_1024
                'int_Box_do = int_Box_do_1024
                'int_lbl_x1 = int_lbl_x1_1024
                'int_lbl_h = int_lbl_h_1024
                'int_lbl_w = int_lbl_w_1024
                'int_tx_h = int_tx_h_1024
                'int_ButH = int_ButH_1024
            End If

            REM *---------------------------------------------------*
            REM *  Höhenermittlung der Fensterteile                 *
            REM *  Gesamthöhe ist vom System vorgegeben (FULL)      *
            REM *---------------------------------------------------*
            .pan_Navi.Height = int_Navi_Height
            .Stat.Height = int_Stst_Height
            int_Daten_Height = int_Screen_H - int_Menue_Height - int_Navi_Height - int_Stst_Height - int_gbx_Height - (int_BordW * 3)
            .pan_Daten.Height = int_Daten_Height

            int_spc1_height = int_Daten_Height
            int_spc1_pan1_height = int_spc1_height - 20
            int_spc1_pan2_height = int_spc1_height - 20
            int_gbx_Height = 50

            REM *---------------------------------------------------*
            REM *  Maskenkomponenten 01 (rechts)                    *
            REM *---------------------------------------------------*
            int_Daten_01 = int_spc1_height - int_gbx_Height

            int_Vater_Height = int_lbl_Height * 3
            int_Mutter_Height = int_lbl_Height * 3

            int_Listbox_Gesamt_Height = int_Daten_01 - int_Vater_Height - int_Mutter_Height
            int_Listbox_Gesamt_Height -= (int_lbl_Height * 6)
            int_lbx_Geschw_Height = int_Listbox_Gesamt_Height * 0.4
            int_lbx_Ehe_Height = int_Listbox_Gesamt_Height * 0.2
            int_lbx_Kinder_Height = int_Listbox_Gesamt_Height * 0.4

            int_lbx_Paten_Height = int_Listbox_Gesamt_Height * 0.2
            int_lbx_Zeugen_Height = int_Listbox_Gesamt_Height * 0.15

            int_rtx_Text_Height = int_Listbox_Gesamt_Height * 0.9


            REM *---------------------------------------------------*
            REM *  Breitenermittlung der Fensterteile               *
            REM *  Gesamthöhe ist vom System vorgegeben (FULL)      *
            REM *---------------------------------------------------*
            int_Navi_Width = int_SC_FormW
            .pan_Navi.Width = int_Navi_Width
            int_Stst_Width = int_SC_FormW
            .Stat.Width = int_Stst_Width
            int_Daten_Width = int_SC_FormW
            .pan_Daten.Width = int_Daten_Width

            int_spc1_width = int_Daten_Width
            int_spc1_pan1_width = (int_spc1_width - (int_BordW * 3)) / 2
            int_spc1_pan2_width = (int_spc1_width - (int_BordW * 3)) / 2

            int_tb1_Width = int_spc1_pan1_width

            int_SplitDisW = int_spc1_pan1_width + int_SplitDisP
            int_gbx_Width = int_spc1_pan1_width - 20

            int_lbl_Width = (int_spc1_pan1_width - 20) / 8
            int_txt_Width = int_lbl_Width * 6
            int_txt1_Width = int_txt_Width
            int_txt2_Width = int_txt_Width / 2
            int_txt3_width = int_txt_Width / 3
            int_txt4_Width = int_txt_Width / 4
            int_txt5_Width = int_txt_Width / 5
            int_txt6_Width = int_txt_Width / 6

            int_DatTT_Width = int_lbl_Width / 100 * 20
            int_DatMM_Width = int_lbl_Width / 100 * 20
            int_DatJJ_Width = int_lbl_Width / 100 * 44
            int_DatP_Width = int_lbl_Width / 100 * 8
            int_Dat_Height = int_txt_Height '-2


            int_gbx_Width = int_lbl_Width + int_txt_Width
            int_gbx_Height = 50

            int_lbx_Width = int_lbl_Width + int_txt_Width
            int_lbx_Height = 100

            int_rbt01_Height = 70
            int_rbt01_Width = int_spc1_pan2_width - 50

            int_tab_Width = int_spc1_pan2_width - 50
            int_tab_Height = int_spc1_pan2_height - 50 - (int_rbt01_Height + 40)

            int_91_Height = int_SC_FormH - 250
            int_91_Width = int_SC_FormW - 450
            int_gbx91_Width = int_91_Width - 50
            int_gbx91_Height = int_lbl_Height * 11

            int_Grid_W = int_gbx91_Width
            int_Grid_H = int_91_Height - 340

        End With

    End Sub

    REM ******************************************************************
    REM *  Positionieren des Menü-Strips                                 *
    REM ******************************************************************
    Public Shared Sub Mask_Menue()
        int_Pos_y = 5

        With NM_Ahnen
            .MenuStrip.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
        End With
    End Sub

    REM ******************************************************************
    REM *  Positionieren der Navi-Button                                 *
    REM ******************************************************************
    Public Shared Sub Mask_Navi()

        int_Pos_y = 5 + int_Menue_Height
        With NM_Ahnen

            REM *--------------------------------------------------------*
            REM *  Navi-Button für die linke Seite                       *
            REM *--------------------------------------------------------*
            Call Navi_Pos_L(1)
            .bt_00_DB.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_DB.BackColor = col_btn
            .bt_00_DB.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            '.bt_00_DB.FlatAppearance.MouseDownBackColor = col_btn_Mouse
            .bt_00_DB.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_DB.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_DB.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_L(2)
            .bt_00_List.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_List.BackColor = col_btn
            .bt_00_List.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_List.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_List.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_List.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_L(3)
            .bt_00_Search.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Search.BackColor = col_btn
            .bt_00_Search.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Search.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Search.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Search.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_L(4)
            .bt_00_Para.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Para.BackColor = col_btn
            .bt_00_Para.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Para.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Para.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Para.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_L(5)
            .bt_00_Todo.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Todo.BackColor = col_btn
            .bt_00_Todo.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Todo.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Todo.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Todo.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_L(6)
            .bt_00_His.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_His.BackColor = col_btn
            .bt_00_His.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_His.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_His.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_His.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            REM *--------------------------------------------------------*
            REM *  Navi-Button für die rechte Seite                      *
            REM *--------------------------------------------------------*
            Call Navi_Pos_R(1)
            .lbl_00_ID.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .lbl_00_ID.BackColor = col_lbl
            .lbl_00_ID.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
            .lbl_00_ID.Font = font_Label
            .lbl_00_ID.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .lbl_00_ID.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .lbl_00_ID.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            .tx_00_ID.Location = New System.Drawing.Point(int_Pos_x + int_Navi_Button_Width, int_Pos_y)
            .tx_00_ID.BackColor = col_txt
            .tx_00_ID.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
            '.tx_00_ID.Font = font_Foretext
            .tx_00_ID.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width * 2, int_Navi_Button_Height)
            .tx_00_ID.Size = New System.Drawing.Size(int_Navi_Button_Width * 2, int_Navi_Button_Height)
            '.tx_00_ID.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            .bt_00_ID.Location = New System.Drawing.Point(int_Pos_x + (int_Navi_Button_Width * 3), int_Pos_y)
            .bt_00_ID.BackColor = col_btn
            .bt_00_ID.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_ID.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_ID.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_ID.TextAlign = System.Drawing.ContentAlignment.MiddleLeft


            Call Navi_Pos_L(16)
            .bt_00_First.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_First.BackColor = col_btn
            .bt_00_First.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_First.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_First.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_First.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            Call Navi_Pos_L(17)
            .bt_00_Before.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Before.BackColor = col_btn
            .bt_00_Before.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Before.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Before.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Before.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            Call Navi_Pos_L(18)
            .bt_00_Next.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Next.BackColor = col_btn
            .bt_00_Next.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Next.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Next.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Next.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            Call Navi_Pos_L(19)
            .bt_00_Last.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Last.BackColor = col_btn
            .bt_00_Last.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Last.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Last.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Last.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            Call Navi_Pos_R(5)
            .bt_00_Neu.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Neu.BackColor = col_btn
            .bt_00_Neu.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Neu.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Neu.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Neu.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_R(6)
            .bt_00_Del.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Del.BackColor = col_btn
            .bt_00_Del.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Del.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Del.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Del.TextAlign = System.Drawing.ContentAlignment.BottomCenter


        End With

    End Sub

    Public Shared Sub Navi_Pos_L(ByVal i01 As Integer)
        int_Pos_x = 10 + ((i01 - 1) * int_Navi_Button_Width) + ((i01 - 1) * int_BDiff)

    End Sub

    Public Shared Sub Navi_Pos_R(ByVal i01 As Integer)
        int_Pos_x = int_SplitDisW + ((i01 - 1) * int_Navi_Button_Width) + ((i01 - 1) * int_BDiff)

    End Sub

    REM ******************************************************************
    REM *  Anzeige der Statuszeile                                       *
    REM *  die einzelnen Elemente werden prozentual bemaßt               *
    REM ******************************************************************
    Public Shared Sub Mask_Pos_Status()

        Dim dbl_W1_Proz As Double = 10.0
        Dim dbl_W2_Proz As Double = 5.0
        Dim dbl_W3_Proz As Double = 11.0
        Dim dbl_W4_Proz As Double = 10.0
        Dim dbl_W5_Proz As Double = 10.0
        Dim dbl_W6_Proz As Double = 10.0
        Dim dbl_W7_Proz As Double = 10.0
        Dim dbl_W8_Proz As Double = 5.0
        Dim dbl_W9_Proz As Double = 5.0
        Dim dbl_W10_Proz As Double = 5.0
        Dim dbl_W11_Proz As Double = 5.0
        Dim dbl_W12_Proz As Double = 12.0
        Dim dbl_W As Integer
        Dim int_WG As Integer = int_Screen_W

        With NM_Ahnen

            .Stat.Location = New System.Drawing.Point(0, int_Screen_H - 40)
            .Stat.Size = New System.Drawing.Size(int_WG, int_Stat_H1)

            '
            dbl_W = int_WG * dbl_W1_Proz / 100
            .Stat_Copyright.AutoSize = False
            .Stat_Copyright.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat_Copyright.Text = str_Copyright
            .Stat_Copyright.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            '
            dbl_W = int_WG * dbl_W2_Proz / 100
            .Stat_Prog.AutoSize = False
            .Stat_Prog.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat_Prog.Text = str_Prog_Name
            .Stat_Prog.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            dbl_W = int_WG * dbl_W3_Proz / 100
            .Stat_Release.AutoSize = False
            .Stat_Release.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat_Release.Text = str_Prog_Rel
            .Stat_Release.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            dbl_W = int_WG * dbl_W4_Proz / 100
            .Stat_DB.AutoSize = False
            .Stat_DB.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat_DB.Text = "NM_Ahnen"
            .Stat_DB.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            '
            dbl_W = int_WG * dbl_W5_Proz / 100
            .Stat_Anzahl.AutoSize = False
            .Stat_Anzahl.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat_Anzahl.Text = "Anzahl:"
            .Stat_Anzahl.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            dbl_W = int_WG * dbl_W6_Proz / 100
            .Stat_Datum.AutoSize = False
            .Stat_Datum.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat_Datum.Text = str_AktDatP
            .Stat_Datum.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            '
            dbl_W = int_WG * dbl_W6_Proz / 100
            .Stat_Zeit.AutoSize = False
            .Stat_Zeit.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat_Zeit.Text = TimeString
            .Stat_Zeit.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

        End With

    End Sub


    REM ******************************************************************
    REM *  Verstecken der Tabellenreiter für Tab1                        *
    REM ******************************************************************
    Public Shared Sub Tab1_Hidden()

        With NM_Ahnen
            .tb1.SizeMode = TabSizeMode.Fixed
            .tb1.ItemSize = New Size(0, 1)
            .tb1.Appearance = TabAppearance.Buttons
        End With

    End Sub

End Class
